// PG_SplashWnd.cpp : implementation file
//

#include "stdafx.h"
#include "PCPages32.h"
#include "PG_SplashWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// PG_SplashWnd

PG_SplashWnd::PG_SplashWnd()
{
	m_bShowSplashWnd = FALSE;
	m_bCreated = FALSE;
}

PG_SplashWnd::~PG_SplashWnd()
{
}

BEGIN_MESSAGE_MAP(PG_SplashWnd, CWnd)
	//{{AFX_MSG_MAP(PG_SplashWnd)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void PG_SplashWnd::EnableSplashScreen(BOOL bEnable /*= TRUE*/)
{
	m_bShowSplashWnd = bEnable;
}

void PG_SplashWnd::ShowSplashScreen(CWnd* pParentWnd /*= NULL*/)
{
	if ( !m_bShowSplashWnd )
		return;

	// Allocate a new splash screen, and create the window.
	UpdateWindow();
}

BOOL PG_SplashWnd::PreTranslateAppMessage(MSG* pMsg)
{
	// If we get a keyboard or mouse message, hide the splash screen.
	if (pMsg->message == WM_KEYDOWN ||
	    pMsg->message == WM_SYSKEYDOWN ||
	    pMsg->message == WM_LBUTTONDOWN ||
	    pMsg->message == WM_RBUTTONDOWN ||
	    pMsg->message == WM_MBUTTONDOWN ||
	    pMsg->message == WM_NCLBUTTONDOWN ||
	    pMsg->message == WM_NCRBUTTONDOWN ||
	    pMsg->message == WM_NCMBUTTONDOWN)
	{
		HideSplashScreen();
		return TRUE;	// message handled here
	}

	return FALSE;	// message not handled
}

BOOL PG_SplashWnd::Create(CWnd* pParentWnd /*= NULL*/)
{
	if ( m_bCreated == TRUE )
		return TRUE;

	if (!m_bitmap.LoadBitmap(IDB_SPLASH))
		return FALSE;

	BITMAP bm;
	m_bitmap.GetBitmap(&bm);

	BOOL bOK =
		CreateEx(WS_EX_DLGMODALFRAME|WS_EX_TOPMOST,
			AfxRegisterWndClass(0, AfxGetApp()->LoadStandardCursor(IDC_ARROW)),
			NULL,
			WS_POPUP | WS_VISIBLE,
			0, 0,
			bm.bmWidth+GetSystemMetrics(SM_CXEDGE),
			bm.bmHeight+GetSystemMetrics(SM_CYEDGE),
			pParentWnd->GetSafeHwnd(), NULL);

	if ( bOK )
		m_bCreated = TRUE;

	return bOK;
}

void PG_SplashWnd::HideSplashScreen()
{
	if ( m_bCreated == FALSE )
		return;

	// Destroy the window, and update the mainframe.
	DestroyWindow();
	m_bCreated = FALSE;
}

void PG_SplashWnd::PostNcDestroy()
{
}

int PG_SplashWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Center the window.
	CenterWindow(AfxGetMainWnd());

	// Set a timer to destroy the splash screen.
	SetTimer(1, 5000, NULL);

	return 0;
}

void PG_SplashWnd::OnPaint()
{
	CPaintDC dc(this);

	CDC dcImage;
	if (!dcImage.CreateCompatibleDC(&dc))
		return;

	BITMAP bm;
	m_bitmap.GetBitmap(&bm);

  //
	// Paint the image.
	CBitmap* pOldBitmap = dcImage.SelectObject(&m_bitmap);
	dc.BitBlt(0, 0, bm.bmWidth, bm.bmHeight, &dcImage, 0, 0, SRCCOPY);
	dcImage.SelectObject(pOldBitmap);
}

void PG_SplashWnd::OnTimer(UINT nIDEvent)
{
	// Destroy the splash screen window.
	HideSplashScreen();
}

/////////////////////////////////////////////////////////////////////////////
// PG_SplashWnd message handlers
